<template>
  <v-row>
    <v-col cols="3">
      <v-sheet rounded="lg">
        <v-list color="transparent">
          <div class="text-h6 text-center">Filtros</div>
          <v-list-item>
            <v-list-item-content>
              <v-autocomplete
                  label="Provincia"
                  v-model="selectedState"
                  :items="states"
                  :loading="loadingState"
                  item-text="nombre"
                  return-object
                  outlined
                  hide-details
                  clearable
              >
              </v-autocomplete>
            </v-list-item-content>
          </v-list-item>
          <v-list-item>
            <v-list-item-content>
              <v-autocomplete
                  label="Localidad"
                  v-model="selectedCity"
                  :items="cities"
                  :loading="loadingCity"
                  item-text="nombre"
                  return-object
                  outlined
                  hide-details
                  clearable
              >
                <template v-slot:item="data">
                  <div style="flex: auto">
                    <div class="float-left">{{ data.item.nombre }}</div>
                    <div class="float-right">{{ occurrencesOfCity(data.item.nombre) }}</div>
                  </div>
                </template>
              </v-autocomplete>
            </v-list-item-content>
          </v-list-item>
        </v-list>
      </v-sheet>
    </v-col>
    <v-col>
      <v-data-table
          :headers="headers"
          :items="filteredItems"
          :items-per-page="10"
          :sort-by="['city', 'address']"
          :sort-desc="[false, false]"
          multi-sort
          class="elevation-1"
      >
        <template v-slot:top>
          <v-toolbar
              flat
          >
            <v-spacer></v-spacer>
            <v-dialog
                v-model="dialog"
                max-width="500px"
            >
              <template v-slot:activator="{ on, attrs }">
                <v-btn
                    dark
                    class="mb-2"
                    v-bind="attrs"
                    v-on="on"
                >
                  Nueva Carta
                </v-btn>
              </template>
              <v-card>
                <v-card-title>
                  <span class="headline">{{ formTitle }}</span>
                </v-card-title>

                <v-card-text>
                  <v-container>
                    <v-row>
                      <v-col>
                        <v-text-field
                            v-model="editedItem.clientId"
                            label="Número de cliente"
                            outlined
                            hide-details
                        ></v-text-field>
                      </v-col>
                      <v-col>
                        <v-text-field
                            v-model="editedItem.name"
                            label="Nombre y Apellido"
                            outlined
                            hide-details
                        ></v-text-field>
                      </v-col>
                    </v-row>
                    <v-row>
                      <v-col
                          cols="12"
                          sm="6"
                          md="4"
                      >
                        <v-autocomplete
                            label="Provincia"
                            v-model="editedItem.state"
                            :items="editedStates"
                            item-text="nombre"
                            return-object
                            outlined
                            hide-details
                            @change="setEditedCities()"
                        >
                        </v-autocomplete>
                      </v-col>
                      <v-col
                          cols="12"
                          sm="6"
                          md="4"
                      >
                        <v-autocomplete
                            label="Localidad"
                            v-model="editedItem.city"
                            :items="editedCities"
                            item-text="nombre"
                            item-value="nombre"
                            outlined
                            hide-details
                            clearable
                        >
                        </v-autocomplete>
                      </v-col>
                      <v-col
                          cols="12"
                          sm="6"
                          md="4"
                      >
                        <v-text-field
                            v-model="editedItem.zipCode"
                            label="Código Postal"
                            outlined
                            hide-details
                        ></v-text-field>
                      </v-col>
                    </v-row>
                    <v-row>
                      <v-col>
                        <v-text-field
                            v-model="editedItem.address"
                            label="Dirección"
                            outlined
                            hide-details
                        ></v-text-field>
                      </v-col>
                      <v-col>
                        <v-text-field
                            v-model="editedItem.amount"
                            label="Monto"
                            outlined
                            hide-details
                        ></v-text-field>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-card-text>

                <v-card-actions>
                  <v-spacer></v-spacer>
                  <v-btn
                      text
                      @click="close"
                  >
                    Cancelar
                  </v-btn>
                  <v-btn
                      text
                      @click="save"
                  >
                    Guardar
                  </v-btn>
                </v-card-actions>
              </v-card>
            </v-dialog>
            <v-dialog v-model="dialogDelete" max-width="500px">
              <v-card>
                <v-card-title class="headline">¿Esta seguro de eliminar este item?</v-card-title>
                <v-card-actions>
                  <v-spacer></v-spacer>
                  <v-btn text @click="closeDelete">Cancelar</v-btn>
                  <v-btn text @click="deleteItemConfirm">OK</v-btn>
                  <v-spacer></v-spacer>
                </v-card-actions>
              </v-card>
            </v-dialog>
          </v-toolbar>
        </template>
        <template v-slot:item.actions="{ item }">
          <v-menu bottom left>
            <template v-slot:activator="{ on }">
              <v-icon v-on="on">mdi-dots-vertical</v-icon>
            </template>
            <v-list class="pa-0">
              <v-list-item @click="editItem(item)">
                <v-list-item-title>
                  <v-icon>mdi-pencil</v-icon> Editar
                </v-list-item-title>
              </v-list-item>
              <v-list-item @click="deleteItem(item)">
                <v-list-item-title>
                  <v-icon>mdi-delete</v-icon> Eliminar
                </v-list-item-title>
              </v-list-item>
            </v-list>
          </v-menu>
        </template>
        <template v-slot:no-data>
          <v-btn
              color="primary"
              @click="initialize"
          >
            Reset
          </v-btn>
        </template>
      </v-data-table>
    </v-col>
  </v-row>
</template>

<script>
export default {
  name: "E1_1",
  data() {
    return {
      dialog: false,
      dialogDelete: false,
      headers: [
        {
          text: '#',
          value: 'clientId',
          sortable: false,
          align: 'center'
        },
        {
          text: 'Nombre y Apellido',
          value: 'name',
          sortable: false
        },
        {
          text: 'Provincia',
          value: 'state',
          sortable: false
        },
        {
          text: 'Localidad',
          value: 'city'
        },
        {
          text: 'Código Postal',
          value: 'zipCode',
          sortable: false
        },
        {
          text: 'Dirección',
          value: 'address'
        },
        {
          text: 'Monto',
          value: 'amount',
          sortable: false
        },
        {
          text: '',
          value: 'actions'
        }
      ],
      items: [
        {
          clientId: '1',
          name: 'Marcos Sosa',
          address: 'Av. Colón 123',
          state: 'Chaco',
          city: 'Resistencia',
          zipCode: '3500',
          amount: '$ -2000'
        },
        {
          clientId: '2',
          name: 'Maria Lopez',
          address: 'Ayacucho 321',
          state: 'Chaco',
          city: 'Resistencia',
          zipCode: '3500',
          amount: '$ -10000'
        },
        {
          clientId: '3',
          name: 'Lucas Montenegro',
          address: 'Alvear 123',
          state: 'Misiones',
          city: 'Posadas',
          zipCode: '3300',
          amount: '$ -12345'
        },
        {
          clientId: '4',
          name: 'Gabriel Diaz',
          address: 'Cordoba 32',
          state: 'Chaco',
          city: 'Resistencia',
          zipCode: '3400',
          amount: '$ -43000'
        },
        {
          clientId: '5',
          name: 'Jorge Cativa',
          address: 'Castelli 432',
          state: 'Chaco',
          city: 'Resistencia',
          zipCode: '3400',
          amount: '$ -9000'
        },
        {
          clientId: '6',
          name: 'Andrea Gomez',
          address: 'Baibiene 543',
          state: 'Corrientes',
          city: 'Corrientes',
          zipCode: '3500',
          amount: '$ -18500'
        }
      ],
      states: [],
      selectedState: null,
      loadingState: false,
      cities: [],
      selectedCity: null,
      loadingCity: false,
      editedIndex: -1,
      editedItem: {
        clientId: '',
        name: '',
        address: '',
        state: '',
        city: '',
        zipCode: '',
        amount: ''
      },
      editedStates: [],
      editedCities: [],
      defaultItem: {
        clientId: '',
        name: '',
        address: '',
        state: '',
        city: '',
        zipCode: '',
        amount: ''
      },
    };
  },
  watch: {
    selectedState(val) {
      this.loadingCity = true;
      try {
        fetch(`https://apis.datos.gob.ar/georef/api/municipios?provincia=${val.id}&campos=id,nombre&max=100`)
            .then(response => response.json())
            .then(data => this.cities = data.municipios)
      } catch (err) {
        this.cities = []
        throw err
      } finally {
        this.loadingCity = false
      }
    },
    dialog(val) {
      val || this.close();
    },
    dialogDelete(val) {
      val || this.closeDelete();
    }
  },
  computed: {
    filteredItems() {
      if (this.selectedCity) {
        return this.items.filter(item => item.city == this.selectedCity.nombre)
      } else {
        if (this.selectedState) {
          return this.items.filter(item => item.state == this.selectedState.nombre)
        } else {
          return this.items
        }
      }
    },
    formTitle() {
      return this.editedIndex === -1 ? 'Nueva Carta' : 'Editar Carta';
    }
  },
  mounted() {
    this.getStates();
  },
  methods: {
    getStates() {
      this.loadingState = true;
      try {
        fetch('https://apis.datos.gob.ar/georef/api/provincias?campos=id,nombre')
            .then(response => response.json())
            .then(data => { this.states = data.provincias; this.editedStates = data.provincias })
      } catch(err) {
        this.states = [];
        throw err;
      } finally {
        this.loadingState = false
      }
    },
    occurrencesOfCity(city) {
      return this.items.filter(item => item.city == city).length;
    },
    setEditedCities() {
      fetch(`https://apis.datos.gob.ar/georef/api/municipios?provincia=${this.editedItem.state.id}&campos=id,nombre&max=100`)
          .then(response => response.json())
          .then(data => this.editedCities = data.municipios)
          .catch(function (err) {
            this.cities = [];
            throw err;
          });
    },
    editItem(item) {
      this.editedIndex = this.items.indexOf(item);
      this.editedItem = Object.assign({}, item);
      this.dialog = true;
    },

    deleteItem(item) {
      this.editedIndex = this.items.indexOf(item);
      this.editedItem = Object.assign({}, item);
      this.dialogDelete = true;
    },

    deleteItemConfirm() {
      this.items.splice(this.editedIndex, 1);
      this.closeDelete();
    },

    close() {
      this.dialog = false;
      this.$nextTick(() => {
        this.editedItem = Object.assign({}, this.defaultItem);
        this.editedIndex = -1;
      });
    },

    closeDelete() {
      this.dialogDelete = false;
      this.$nextTick(() => {
        this.editedItem = Object.assign({}, this.defaultItem);
        this.editedIndex = -1;
      });
    },

    save() {
      this.editedItem.state = this.editedItem.state.nombre
      if (this.editedIndex > -1) {
        Object.assign(this.items[this.editedIndex], this.editedItem);
      } else {
        this.items.push(this.editedItem);
      }
      this.close();
    }
  }
};
</script>

<style scoped>

</style>
